; Probability monad in Scheme.

(load "utils.scm")

; shortened names for these
(define f force)
(define call/cc call-with-current-continuation)

; "constructors" (should I be using OCaml?)
(define (p_choose p a b)
  (lambda (choose then return observe) (choose p a b)))
(define (p_then f g)
  (lambda (choose then return observe) (then f g)))
(define (p_return x)
  (lambda (choose then return observe) (return x)))
(define (p_observe p a)
  (lambda (choose then return observe) (observe p a)))

(define (flip p) (p_choose p (p_return #t) (p_return #f)))

; (use 'random)  XXX alas this is broken...
; FIXME: stupendously bad RNG
(define (random_float)
  (/ (modulo (time) 10) 10.0))

; sampling from a distribution
(define (sample n)
  (let ((choose
	 (lambda (p a b)
	   (if (< (random_float) p)
	       (sample a)
	       (sample b))))
	(then
	 (lambda (f g)
	   (sample (g (sample f)))))
	(return
	 (lambda (x) x))
	(observe
	 (lambda (p a)
	   'FIXME)))
    (n choose then return observe)))

; computes distribution of values of a program
(define (dist1 n)
  (let ((choose    ; choose between two subnetworks with some probability
	 (lambda (p a b)
	   (simplify_dist
	    (append
	     (weight_dist (log p) (dist1 a))
	     (weight_dist (log (- 1 p)) (dist1 b))))))
	(then
	 (lambda (f g)
          (simplify_dist
	   (call/cc
            (lambda (exit)
             (dist1 (g (delay (exit  ; fast case -- g is independent of x
	      (reduce append         ; slow case -- g depends on x
	       (map
	        (lambda (x) 
                 (weight_dist (cdr x) (dist1 (g (car x)))))
	        (dist1 f))))))))))))
       (return            ; base case - just return a value
	 (lambda (x) `( (,x . 0) )))
       (observe
	(lambda (p a)
	  (if p           ; if "observed" condition is true
	      (dist1 a)   ; include distribution of a
	      '()))))     ; otherwise return nothing
    (n choose then return observe)))

; because of "observe", we need to normalize this afterwards
(define (dist n)
  (normalize_dist (dist1 n)))


; EM?
; should this just return a new program?

